<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <title>jquery Ajax: load users, update users...</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<body>

  <div class="container">

    <h3>Sample function calls</h3>

    <div class="row form-group">
      <button class="btn btn-success m-1" onclick="loadDataUsers()">(1.1) Load List users </button>
      <button class="btn btn-success m-1" onclick="getUserDataById()">(2.1) Get User info by Id</button>
      <button class="btn btn-success m-1" onclick="callRestApiUpdate()">(3.1) Update User info </button>
    </div>
    <div class="row form-group">
      <button class="btn btn-danger m-1" onclick="loadAjaxDataUsers()">(1.2) jquery ajax: Load list users </button>
      <button class="btn btn-info m-1" onclick="getAjaxUserDataById()">(2.2) jquery ajax: Get User info by ID </button>
      <button class="btn btn-warning m-1" onclick="callAjaxRestApiUpdate()">(3.2) jquery ajax: Update User info
      </button>
    </div>
  </div>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_READY_STATE_FINISH_OK = 4;
    const gREQUEST_STATUS_OK = 200;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    /*
    * load user data
    */
    function loadDataUsers() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATE_FINISH_OK && this.status == gREQUEST_STATUS_OK) {
          console.log("responseText = " + vXhttp.responseText);
        }
      };
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-register-java-api/users", true);
      vXhttp.send();
    }

    //sample function get user data by id
    function getUserDataById() {
      var vUserId = "175184";
      var vXhttp = new XMLHttpRequest();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATE_FINISH_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText);  // xem trên console.log để biết cấu trúc
        }
      };
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-register-java-api/users/" + vUserId, true);
      vXhttp.send();
    }

    /*
    * load user data
    */
    function loadAjaxDataUsers() {
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: 'GET',
        dataType: 'json', // added data type
        success: function (res) {
          console.log(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText)
        }
      });
    }

    //sample function get user data by id
    function getAjaxUserDataById() {
      var vUserId = "175184";

      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users/" + vUserId,
        type: 'GET',
        dataType: 'json', // added data type
        success: function (res) {
          console.log(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText)
        }
      });
    }

    //update user info
    function callRestApiUpdate() {
      var vUserId = "195335";
      //data to be sent 
      var vObjectRequestData = {
        firstname: "Mike",  //bạn có thể sửa các giá trị này để thử, và lại get lại data 
        lastname: "Donasky",
        subject: "On business 200",
        country: "USA"
      };
      //      
      var vXmlhttp = new XMLHttpRequest();   // new HttpRequest instance 
      var vUrlUpdateInfo = "http://203.171.20.210:8080/devcamp-register-java-api/users/" + vUserId;

      vXmlhttp.open("PUT", vUrlUpdateInfo);
      vXmlhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      vXmlhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATE_FINISH_OK && this.status == gREQUEST_STATUS_OK) {
          console.log("Cap nhat thong tin thanh cong: " + this.responseText);
        }
      }
      vXmlhttp.send(JSON.stringify(vObjectRequestData)); //send request
    }
    //update user info, ajax call 
    function callAjaxRestApiUpdate() {
      // 1. Đọc dữ liệu
      var vUserId = "196520";
      //data to be sent 
      var vObjectRequestData = {
        firstname: "Nguyen",  //bạn có thể sửa các giá trị này để thử, và lại get lại data 
        lastname: "Tran",
        subject: "On business 1200",
        country: "UK"
      };
      //2 . Kiểm tra (không cần thực hiện)
      //3. Gọi server  phải implement ajax put call tại đây (gọi rest API by Ajax)
      /***  ..............code của bạn ở đây ......................****/
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users/" + vUserId,
        type: 'PUT',
        contentType:"application/json;charset=UTF-8",
        data:JSON.stringify(vObjectRequestData),
        dataType: 'json', // added data type
        success: getUserByIdSuccessHandle,
        error: getUserByIdErrorHandle
      });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm callback xử lý khi gọi api thành công
    function getUserByIdSuccessHandle(paramResponse) {
      console.log('success callback...');
      console.log(paramResponse);
      console.log(Object.entries(paramResponse));  
    }

    //hàm callback xử lý khi gọi api bị lỗi
    function getUserByIdErrorHandle(paramResponse) {
      console.log('error callback...');
      console.log(paramResponse); 
    }
  </script>

</body>

</html>